define([
    "dojo/_base/window",
    "dojo/dom",
    "dojo/_base/declare",
    "dijit/_WidgetBase"
], function(window, dom, declare, _WidgetBase) {
     console.log("REQUIRED Dispatcher");
     window.global.app = {
       name: "ymtree",
       treeInitialState: "collapsed", // can be "expanded" and "collapsed".
       widgets: {}
     };
     return declare([_WidgetBase], {
       widgetLabel: "Dispatcher",
       humanname: "",
       postCreate: function()
       {
         console.log("Dispatcher postCreate this:", this);
         console.log("Dispatcher postCreate window:", window);
         window.global.app.widgets.Dispatcher = this;
       },

       enableTabs: function()
       {
         console.log("enableTabs:", window.global.app.widgets.GeneralPane);
         window.global.app.widgets.GeneralPane.tab1.set("disabled", false);
         window.global.app.widgets.GeneralPane.tab2.set("disabled", false);
         window.global.app.widgets.GeneralPane.tab3.set("disabled", false);
         window.global.app.widgets.GeneralPane.tab4.set("disabled", false);
         window.global.app.widgets.GeneralPane.tab5.set("disabled", false);
         for(var i=1; i<=5; i++)
         {
           window.global.app.widgets.GeneralPane.mainTabContainer.domNode.childNodes[1].children[3].children[0].children[i].style.visibility = "visible";
         }
       },

       disableTabs: function()
       {
         console.log("disableTabs:", window.global.app.widgets.GeneralPane);
         window.global.app.widgets.GeneralPane.mainTabContainer.selectChild(window.global.app.widgets.GeneralPane.tab0);
         window.global.app.widgets.GeneralPane.tab1.set("disabled", true);
         window.global.app.widgets.GeneralPane.tab2.set("disabled", true);
         window.global.app.widgets.GeneralPane.tab3.set("disabled", true);
         window.global.app.widgets.GeneralPane.tab4.set("disabled", true);
         window.global.app.widgets.GeneralPane.tab5.set("disabled", true);
         for(var i=1; i<=5; i++)
         {
           window.global.app.widgets.GeneralPane.mainTabContainer.domNode.childNodes[1].children[3].children[0].children[i].style.visibility = "hidden";
         }
       },

       showLogoutPane: function()
       {
         console.log("Dispatcher showLogoutPane:", this);
         this.mainContainer.removeChild(this.loginContainer);
         this.mainContainer.addChild(this.logoutContainer);
         // var node = dom.byId("greeting");
         this.logoutContainer.Humanname.innerHTML = "Welcome, " + this.humanname + "!";
       },

       showLoginPane: function()
       {
         console.log("Dispatcher showLoginPane:", this);
         this.mainContainer.removeChild(this.logoutContainer);
         this.mainContainer.addChild(this.loginContainer);
         this.humanname = "";
       }
     });
});
