<?php
  require("dbconnect_backup.php");
  require("do_session.php");
  if(isset($userid))
  {
    $response1 = array();
    $vsamples_gpids = array("NGXHD27P7R","NG5VR24VFX","NG44BCV5FL","NG3MH88T66","NGEMB269Y2","NG7K9C6Q9X","NG7GKD9HX3","NG3N9A7EAN","NG3G7D9LXT","NG3G53S83A");
    for($i=0; $i<count($vsamples_gpids); $i++)
    {
      $o_current = new stdClass();
      $gpid = $vsamples_gpids[$i];
      $rc8 = substr($gpid, 0, 2);
      $gpid8 = substr($gpid, 2);
      $o_current->id = $gpid . "_current";
      $o_current->currency =  "current";
      $o_current->gpid = $gpid;
  
      $o_current->gprecord_status = "OK";
      $query = "select * from geno.gprecord where rc='$rc8' and gpid='$gpid8'";
      $result = pg_query($dbconn_current, $query);
      $gprecord_current = pg_fetch_array($result, 0, PGSQL_ASSOC);
      pg_free_result($result); 
  
      $gprecord_current['create_date'] = substr($gprecord_current['create_date'], 0, 19);
      $gprecord_current['lastupdated'] = substr($gprecord_current['lastupdated'], 0, 19);
      $r = print_r($gprecord_current, TRUE);
      $o_current->gprecord = substr($r, 7, strlen($r) - 10);
  
      $o_current->haplosnps_status = "OK";
      $o_current->haplosnps = "";
      $query = "select * from geno.haplosnps where rc='$rc8' and gpid='$gpid8' order by snp;";
      $result = pg_query($dbconn_current, $query);
      while($haplosnps = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_current->haplosnps = $o_current->haplosnps . $haplosnps['snp'] . "\n";
      }
      pg_free_result($result);
  
      $o_current->msnps_status = "OK";
      $o_current->msnps = "";
      $query = "select * from geno.msnps where rc='$rc8' and gpid='$gpid8' order by position;";
      $result = pg_query($dbconn_current, $query);
      while($msnps = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_current->msnps = $o_current->msnps . $msnps['position'] . $msnps['value'] . "\n";
      }
      pg_free_result($result);
  
      $o_current->mranges_status = "OK";
      $o_current->mranges = "";
      $query = "select * from geno.mranges where rc='$rc8' and gpid='$gpid8' order by start_position;";
      $result = pg_query($dbconn_current, $query);
      while($mranges = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_current->mranges = $o_current->mranges . $mranges['start_position'] . "-" . $mranges['end_position'] . "\n";
      }
      pg_free_result($result);
  
      $o_current->admixture_status = "OK";
      $o_current->admixture = "";
      $admarray_current = array();
      $query = "select * from geno.admixture where rc='$rc8' and gpid='$gpid8' and popid < 100 order by popid;";
      $result = pg_query($dbconn_current, $query);
      while($admixture = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_current->admixture = $o_current->admixture . $admixture['popid'] . ":"  . $admixture['share'] . "\n";
        $admarray_current[$admixture['popid']] = $admixture['share'];
      }
      pg_free_result($result);
  
      $o_current->closest_status = "OK";
      $o_current->closest = "";
      $query = "select * from geno.admixture where rc='$rc8' and gpid='$gpid8' and popid >= 100 order by popid;";
      $result = pg_query($dbconn_current, $query);
      while($admixture = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_current->closest = $o_current->closest . $admixture['popid'] . ":"  . $admixture['share'] . "\n";
      }
      pg_free_result($result);
  
      $o_backup = new stdClass();
      $o_backup->id = $gpid . "_backup";
      $o_backup->currency =  "backup";
      $o_backup->gpid = $gpid;
  
      $o_backup->gprecord_status = "OK";
      $query = "select * from geno.gprecord where rc='$rc8' and gpid='$gpid8'";
      $result = pg_query($dbconn_backup, $query);
      $gprecord_backup = pg_fetch_array($result, 0, PGSQL_ASSOC);
      pg_free_result($result); 
  
      $gprecord_backup['create_date'] = substr($gprecord_backup['create_date'], 0, 19);
      $gprecord_backup['lastupdated'] = substr($gprecord_backup['lastupdated'], 0, 19);
      $r = print_r($gprecord_backup, TRUE);
      $o_backup->gprecord = substr($r, 7, strlen($r) - 10);
      $gprecord_backup['lastupdated'] = "";
      $gprecord_backup['create_date'] = "";
      $gprecord_current['lastupdated'] = "";
      $gprecord_current['create_date'] = "";
      if($gprecord_backup != $gprecord_current)
      {
        // echo $gprecord_backup;
        // echo $gprecord_current;
        $o_backup->gprecord_status = "mismatch";
        $o_current->gprecord_status = "mismatch";
      }

      $o_backup->haplosnps_status = "OK";
      $o_backup->haplosnps = "";
      $query = "select * from geno.haplosnps where rc='$rc8' and gpid='$gpid8' order by snp;";
      $result = pg_query($dbconn_backup, $query);
      while($haplosnps = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_backup->haplosnps = $o_backup->haplosnps . $haplosnps['snp'] . "\n";
      }
      pg_free_result($result);
      if($o_backup->haplosnps != $o_current->haplosnps)
      {
        $o_backup->haplosnps_status = "mismatch";
        $o_current->haplosnps_status = "mismatch";
      }
  
      $o_backup->msnps_status = "OK";
      $o_backup->msnps = "";
      $query = "select * from geno.msnps where rc='$rc8' and gpid='$gpid8' order by position;";
      $result = pg_query($dbconn_backup, $query);
      while($msnps = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_backup->msnps = $o_backup->msnps . $msnps['position'] . $msnps['value'] . "\n";
      }
      pg_free_result($result);
      if($o_backup->msnps != $o_current->msnps)
      {
        $o_backup->msnps_status = "mismatch";
        $o_current->msnps_status = "mismatch";
      }
  
      $o_backup->mranges_status = "OK";
      $o_backup->mranges = "";
      $query = "select * from geno.mranges where rc='$rc8' and gpid='$gpid8' order by start_position;";
      $result = pg_query($dbconn_backup, $query);
      while($mranges = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_backup->mranges = $o_backup->mranges . $mranges['start_position'] . "-" . $mranges['end_position'] . "\n";
      }
      pg_free_result($result);
  
      if($o_backup->mranges != $o_current->mranges)
      {
        $o_backup->mranges_status = "mismatch";
        $o_current->mranges_status = "mismatch";
      }
  
      $o_backup->admixture_status = "OK";
      $o_backup->admixture = "";
      $admarray_backup = array();
      $query = "select * from geno.admixture where rc='$rc8' and gpid='$gpid8' and popid < 100 order by popid;";
      $result = pg_query($dbconn_backup, $query);
      while($admixture = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_backup->admixture = $o_backup->admixture . $admixture['popid'] . ":"  . $admixture['share'] . "\n";
        $admarray_backup[$admixture['popid']] = $admixture['share'];
      }
      pg_free_result($result);
      foreach($admarray_backup as $popid=>$share)
      {
        $share_current = $admarray_current[$popid];
        if($share != 0) $p = $share_current / $share;
        else
        {
          if($share_current == 0)
          {
            $p = 1;
          }
        }
        if($p > 1.03 || $p < 0.95)
        {
          if(abs($share -$share_current) > 0.0009)
          {
            $o_current->admixture_status = "diff";
            $o_backup->admixture_status = "popid: " . $popid;
          }
        }
      }
  
      $o_backup->closest_status = "OK";
      $o_backup->closest = "";
      $query = "select * from geno.admixture where rc='$rc8' and gpid='$gpid8' and popid >= 100 order by popid;";
      $result = pg_query($dbconn_backup, $query);
      while($admixture = pg_fetch_array($result, NULL, PGSQL_ASSOC))
      {
        $o_backup->closest = $o_backup->closest . $admixture['popid'] . ":"  . $admixture['share'] . "\n";
      }
      pg_free_result($result);
  
      if($o_backup->closest != $o_current->closest) 
      {
        $o_current->closest_status = str_replace("\n", ";", $o_current->closest);
        $o_backup->closest_status = str_replace("\n", ";", $o_backup->closest);
      }
  
      array_push($response1, $o_current);
      array_push($response1, $o_backup);
    }
    echo json_encode($response1);
  }
?>
