define([
    "dojo/parser",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/request",
    "dojo/json",
    "dojo/dom",
    "dojo/ready",
    "dojo/_base/window",
    "dojo/store/Memory",
    "dijit/tree/ObjectStoreModel",
    "dijit/Tree",
    "dijit/_WidgetBase",
    "dijit/_OnDijitClickMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Button",
    "dijit/layout/ContentPane",
    "dijit/layout/TabContainer",
    "dijit/Dialog",
    "app/WelcomePane",
    "app/DataPushPane",
    "app/ValidationSamplesPane",
    "app/AdmixturePane",
    "app/AutosomalFilesPane",
    "app/BadRecordsPane",
    "dojo/dom-style",
    "dojo/text!./templates/GeneralPane.html",
    "dojo/domReady!"
], function(parser, declare, lang, request, json, dom,  ready, window, Memory, ObjectStoreModel, Tree, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Button, ContentPane, TabContainer, Dialog, WelcomePane, DataPushPane, ValidationSamplesPane, AdmixturePane, AutosomalFilesPane, BadRecordsPane, style, template, dom1) {
 
     console.log("REQUIRED GeneralPane");

     return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,
        global_window: window,

        onTab0Show: function(x)
        {
          console.log("tab0 show", x, this);
          window.global.app.widgets.WelcomePane.paneExposed();
          if(window.global.app.widgets.Dispatcher.humanname == "")
          {
            window.global.app.widgets.Dispatcher.disableTabs();
          }
        },
        onTab0Hide: function(x)
        {
          console.log("tab0 hide");
        },

        onTab1Show: function(x)
        {
          console.log("tab1 show", x);
          window.global.app.widgets.DataPushPane.paneExposed();
        },
        onTab1Hide: function(x)
        {
          console.log("tab1 hide");
        },

        onTab2Show: function(x)
        {
          console.log("tab2 show", x);
          window.global.app.widgets.ValidationSamplesPane.paneExposed();
        },
        onTab2Hide: function(x)
        {
          console.log("tab2 hide");
        },

        onTab3Show: function(x)
        {
          console.log("tab3 show");
          window.global.app.widgets.AdmixturePane.paneExposed();
        },
        onTab3Hide: function(x)
        {
          console.log("tab3 hide");
        },

        onTab4Show: function(x)
        {
          console.log("tab4 show");
          window.global.app.widgets.AutosomalFilesPane.paneExposed();
        },
        onTab4Hide: function(x)
        {
          console.log("tab4 hide");
        },

        onTab5Show: function(x)
        {
          console.log("tab5 show");
          window.global.app.widgets.BadRecordsPane.paneExposed();
        },
        onTab5Hide: function(x)
        {
          console.log("tab5 hide");
        },

        postCreate: function()
        {
          console.log("GeneralPane postCreate:", this);
          window.global.app.widgets.GeneralPane = this;

/*
          var acctChildren = this.tab1.getChildren();
          console.log("acctChildren:", acctChildren[0]);
          this.tab1.onShow = lang.hitch(acctChildren[0], acctChildren[0].accountsPaneExposed);
*/

          this.tab0.onShow = this.onTab0Show;
          this.tab0.onHide = this.onTab0Hide;

          this.tab1.onShow = this.onTab1Show;
          this.tab1.onHide = this.onTab1Hide;

          this.tab2.onShow = this.onTab2Show;
          this.tab2.onHide = this.onTab2Hide;

          this.tab3.onShow = this.onTab3Show;
          this.tab3.onHide = this.onTab3Hide;

          this.tab4.onShow = this.onTab4Show;
          this.tab4.onHide = this.onTab4Hide;

          this.tab5.onShow = this.onTab5Show;
          this.tab5.onHide = this.onTab5Hide;

        }
    });
});
