define([
  "dijit/Dialog",
  "dojo/parser",
  "dojo/_base/declare",
  "app/Snps",
  "dojo/domReady!"
], function (Dialog, parser, declare, Snps, dom)
  {
    return declare(Dialog, {
      title: 'SNPs',
      style: "height: 670px; width: 1100px;",
      content: 'Loaded successfully!',
      contentpane: null,
      startup: function()
      {
        console.log("SnpsDialog startup:", this);
        this.contentpane = new Snps({gpid: this.gpid, snps:this.data});
        this.contentpane.startup();
        this.set('content', this.contentpane);
        this.set('title', this.title + " for " + this.gpid);
      },
      onCancel: function()
      {
        console.log("Dialog being closed");
        this.contentpane.destroyRecursive(false);
      }
  });

});
