define([
    "dojo/parser",
    "dojo/dom-construct",
    "dojo/_base/window",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/dom",
    "dojo/dom-style",
    "dojo/_base/declare",
    "dijit/_WidgetBase",
    "dijit/_OnDijitClickMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Form",
    "dijit/form/ValidationTextBox",
    "dijit/form/SimpleTextarea",
    "dijit/form/Button",
    "dijit/form/Select",
    "dgrid/Grid",
    "dijit/layout/ContentPane",
    "dijit/layout/BorderContainer",
    "dojo/text!./templates/VSnps.html",
    "dojo/domReady!"
], function(parser, domConstruct, window, lang, on, dom, domStyle,  declare, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Form, ValidationTextBox, SimpleTextarea, Button, Select, Grid, ContentPane, BorderContainer, template,domReady) {

     return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,
        rc: null,
        gpid: null,

        populateSnps: function()
        {
          var mhg = 'H24a1';
          var markers = ["73A", "195T", "73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T","73A", "195T"];
          var columns = {
            current: "Current",
            backup: "Backup"
          };
          var data = [];
          for(var i=0; i<markers.length; i++) data.push({current: markers[i], backup: markers[i] + "_0"});
          this.m_grid = new Grid({columns: columns}, this.m_you1);
          this.m_grid.refresh(data);
          this.m_grid.renderArray(data);
        },

        layoutContainers: function()
        {
          console.log("layoutContainers: this:", this);
          this.populateSnps();
        },

        startup: function()
        {
          console.log("VSnps startup(): this:", this);
          setTimeout(lang.hitch(this, this.layoutContainers), 500);
        }

    });
});
