define([ 
  "dijit/Dialog",
  "dojo/parser",
  "dojo/_base/declare",
  "app/VSnps",
  "dojo/domReady!"
], function (Dialog, parser, declare, VSnps, dom) 
  {
    return declare(Dialog, {
      title: 'SNPs for',
      style: "height: 670px; width: 200px;",
      content: 'Loaded successfully!',
      contentpane: null,
      startup: function()
      {
        console.log("VSnpsDialog startup:", this);
        this.contentpane = new VSnps({gpid: this.gpid, column: this.column, data: this.data});
        this.contentpane.startup();
        this.set('content', this.contentpane);
        this.set('title', this.title + " " + this.gpid);
      },
      onCancel: function()
      {
        console.log("VSnpsDialog being closed");
        this.contentpane.destroyRecursive(false);
      }
  });

});
