<?php
  require("dbconnect_backup.php");
  require("do_session.php");
  if(isset($userid))
  {
    $response['reauth'] = 0;
    $vsamples_gpids = array("NGXHD27P7R","NG5VR24VFX","NG44BCV5FL","NG3MH88T66","NGEMB269Y2","NG7K9C6Q9X","NG7GKD9HX3","NG3N9A7EAN","NG3G7D9LXT","NG3G53S83A");

    for($i=0; $i<count($vsamples_gpids); $i++)
    {
      $gpid = substr($vsamples_gpids[$i], 2);
      $rc = substr($vsamples_gpids[$i], 0, 2);
  
      $response[$rc . $gpid . '_status'] = 'success';
      $response[$rc . $gpid . '_errortext'] = '';
      $response[$rc . $gpid . '_errorno'] = '0';
      $query = "select * from geno.gprecord where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
      $result = pg_query($dbconn_current, $query);
      if(pg_num_rows($result) == 0)
      {
        $response[$rc . $gpid . '_status'] = 'error';
        $response[$rc . $gpid . '_errortext'] = 'requested source GPID not found';
        $response[$rc . $gpid . '_errorno'] = '1';
        pg_free_result($result);
        continue;
      }
      $row = pg_fetch_array($result, NULL, PGSQL_ASSOC);
      $query_names = "";
      $query_values = "";
      foreach($row as $n=>$v)
      {
        if($query_names == "") $query_names = $query_names . $n;
        else $query_names = $query_names . "," . $n;
  
        if(strlen($v) == 0)
        {
          $query_values = $query_values . ",null";
        }
        else
        {
          if($n == 'gpid') $v=$gpid; if($n == 'rc') $v=$rc;
          if($query_values != "") $query_values = $query_values . ",";
          if(is_numeric($v)) $query_values = $query_values . $v;
          else $query_values = $query_values . "'" . $v . "'";
        }
      }
      pg_free_result($result);
  
      $query = "delete from geno.gprecord where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
      $result1 = pg_query($dbconn_backup, $query);
      pg_free_result($result1);
  
      $query = "insert into geno.gprecord (" . $query_names . ") values(" . $query_values . ");";
      $result1 = pg_query($dbconn_backup, $query);
      pg_free_result($result1);
      $response[$rc . $gpid . '_query1'] = $query;
  
      // Phenotype
  
      $query = "select * from geno.phenotype where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
      $result = pg_query($dbconn_current, $query);
      if(pg_num_rows($result) != 0)
      {
        $row = pg_fetch_array($result, NULL, PGSQL_ASSOC);
        $query_names = "";
        $query_values = "";
        foreach($row as $n=>$v)
        {
          if($query_names == "") $query_names = $query_names . $n;
          else $query_names = $query_names . "," . $n;
  
          if(strlen($v) == 0)
          {
            $query_values = $query_values . ",null";
          }
          else
          {
            if($n == 'gpid') $v=$gpid; if($n == 'rc') $v=$rc;
            if($query_values != "") $query_values = $query_values . ",";
            if(is_numeric($v)) $query_values = $query_values . $v;
            else $query_values = $query_values . "'" . $v . "'";
          }
        }
  
        $query = "delete from geno.phenotype where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
        $result1 = pg_query($dbconn_backup, $query);
        pg_free_result($result1);
  
        $query = "insert into geno.phenotype (" . $query_names . ") values(" . $query_values . ");";
        $result1 = pg_query($dbconn_backup, $query);
        pg_free_result($result1);
        $response[$rc . $gpid . '_query2'] = $query;
      }
      pg_free_result($result);
  
      // Admixture
  
      $query = "select * from geno.admixture where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
      $result = pg_query($dbconn_current, $query);
      if(pg_num_rows($result) != 0)
      {
        $query = "delete from geno.admixture where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
        $result1 = pg_query($dbconn_backup, $query);
        pg_free_result($result1);
    
        while(($row = pg_fetch_array($result, NULL, PGSQL_ASSOC)) != FALSE)
        {
          $query_names = "";
          $query_values = "";
          foreach($row as $n=>$v)
          {
            if($query_names == "") $query_names = $query_names . $n;
            else $query_names = $query_names . "," . $n;
    
            if(strlen($v) == 0)
            {
              $query_values = $query_values . ",null";
            }
            else
            {
              if($n == 'gpid') $v=$gpid; if($n == 'rc') $v=$rc;
              if($query_values != "") $query_values = $query_values . ",";
              if(is_numeric($v)) $query_values = $query_values . $v;
              else $query_values = $query_values . "'" . $v . "'";
            }
          }
          $query = "insert into geno.admixture (" . $query_names . ") values(" . $query_values . ");";
          $result1 = pg_query($dbconn_backup, $query);
          pg_free_result($result1);
          $response[$rc . $gpid . '_query3'] = $query;
        }
      }
      pg_free_result($result);
  
      // Haplosnps
  
      $query = "select * from geno.haplosnps where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
      $result = pg_query($dbconn_current, $query);
      if(pg_num_rows($result) != 0)
      {
        $query = "delete from geno.haplosnps where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
        $result1 = pg_query($dbconn_backup, $query);
        pg_free_result($result1);
  
        while(($row = pg_fetch_array($result, NULL, PGSQL_ASSOC)) != FALSE)
        {
          $query_names = "";
          $query_values = "";
          foreach($row as $n=>$v)
          {
            // echo "n:" . $n . "<br>\n";
            // echo "v:" . $v . "<br>\n";
            if($query_names == "") $query_names = $query_names . $n;
            else $query_names = $query_names . "," . $n;
  
            if(strlen($v) == 0)
            {
              $query_values = $query_values . ",null";
            }
            else
            {
              if($n == 'gpid') $v=$gpid; if($n == 'rc') $v=$rc;
              if($query_values != "") $query_values = $query_values . ",";
              if(is_numeric($v)) $query_values = $query_values . $v;
              else $query_values = $query_values . "'" . $v . "'";
            }
          }
          $query = "insert into geno.haplosnps (" . $query_names . ") values(" . $query_values . ");";
          $result1 = pg_query($dbconn_backup, $query);
          pg_free_result($result1);
          $response[$rc . $gpid . '_query4'] = $query;
        }
      }
      pg_free_result($result);
  
      // Msnps
  
      $query = "select * from geno.msnps where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
      $result = pg_query($dbconn_current, $query);
      if(pg_num_rows($result) != 0)
      {
        $query = "delete from geno.msnps where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
        $result1 = pg_query($dbconn_backup, $query);
        pg_free_result($result1);
  
        while(($row = pg_fetch_array($result, NULL, PGSQL_ASSOC)) != FALSE)
        {
          $query_names = "";
          $query_values = "";
          foreach($row as $n=>$v)
          {
            if($query_names == "") $query_names = $query_names . $n;
            else $query_names = $query_names . "," . $n;
  
            if(strlen($v) == 0)
            {
              $query_values = $query_values . ",null";
            }
            else
            {
              if($n == 'gpid') $v=$gpid; if($n == 'rc') $v=$rc;
              if($query_values != "") $query_values = $query_values . ",";
              if(is_numeric($v)) $query_values = $query_values . $v;
              else $query_values = $query_values . "'" . $v . "'";
            }
          }
          $query = "insert into geno.msnps (" . $query_names . ") values(" . $query_values . ");";
          $result1 = pg_query($dbconn_backup, $query);
          pg_free_result($result1);
          $response[$rc . $gpid . '_query5'] = $query;
        }
      }
      pg_free_result($result);
  
      // Mranges
    
      $query = "select * from geno.mranges where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
      $result = pg_query($dbconn_current, $query);
      if(pg_num_rows($result) != 0)
      {
        $query = "delete from geno.mranges where gpid = '" . $gpid . "' and rc = '" . $rc . "';";
        $result1 = pg_query($dbconn_backup, $query);
        pg_free_result($result1);
  
        while(($row = pg_fetch_array($result, NULL, PGSQL_ASSOC)) != FALSE)
        {
          $query_names = "";
          $query_values = "";
          foreach($row as $n=>$v)
          {
            if($query_names == "") $query_names = $query_names . $n;
            else $query_names = $query_names . "," . $n;
  
            if(strlen($v) == 0)
            {
              $query_values = $query_values . ",null";
            }
            else
            {
              if($n == 'gpid') $v=$gpid; if($n == 'rc') $v=$rc;
              if($query_values != "") $query_values = $query_values . ",";
              if(is_numeric($v)) $query_values = $query_values . $v;
              else $query_values = $query_values . "'" . $v . "'";
            }
          }
  
          $query = "insert into geno.mranges (" . $query_names . ") values(" . $query_values . ");";
          $result1 = pg_query($dbconn_backup, $query);
          pg_free_result($result1);
          $response[$rc . $gpid . '_query6'] = $query;
        }
      }
      pg_free_result($result);
    }
  }
  echo json_encode($response);
  pg_close($dbconn_current);
  pg_close($dbconn_backup);
  return;
?>
